#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#include <string.h>
#include <os2.h>
#include "sample.h"

#define STRINGLENGTH 40
#define szLength 128

HAB  hab;
CHAR szString[STRINGLENGTH]="Session Start for Warp Japanese version";
PSZ  pszErrMsg;

/*  Windows Proc  */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

/*  Dialog Proc  */
MRESULT EXPENTRY MyDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 );

/* DosStartSession Proc  */
ULONG DosKick(HWND hwnd,ULONG dostype); //Without WINOS2 seamless
/* WinOS2 Session Start Proc */
ULONG WinKick(HWND hwnd);               //For WINOS2 seamless

HWND hwndClient = NULLHANDLE;         /* Client area window handle    */
HWND hwndFrame  = NULLHANDLE;          /* Frame window handle          */

VOID main (VOID)
{
  HMQ  hmq;                             /* Message queue handle         */
  QMSG qmsg;                            /* Message from message queue   */
  ULONG flCreate;                       /* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM     */
     AbortHello(hwndFrame, hwndClient); /* Terminate the application    */

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortHello(hwndFrame, hwndClient); /* Terminate the application    */

  if (!WinRegisterClass(                /* Register window class        */
     hab,                               /* Anchor block handle          */
     (PSZ)"MyWindow",                   /* Window class name            */
     (PFNWP)MyWindowProc,               /* Address of window procedure  */
     CS_SIZEREDRAW,                     /* Class style                  */
     0                                  /* No extra window words        */
     ))
     AbortHello(hwndFrame, hwndClient); /* Terminate the application    */

   flCreate = FCF_STANDARD &            /* Set frame control flags to   */
             ~FCF_SHELLPOSITION;        /* standard except for shell    */
                                        /* positioning.                 */

  if ((hwndFrame = WinCreateStdWindow(
               HWND_DESKTOP,            /* Desktop window is parent     */
               0,                       /* STD. window styles           */
               &flCreate,               /* Frame control flag           */
               "MyWindow",              /* Client window class name     */
               "",                      /* No window text               */
               0,                       /* No special class style       */
               (HMODULE)0L,           /* Resource is in .EXE file     */
               ID_WINDOW,               /* Frame window identifier      */
               &hwndClient              /* Client window handle         */
               )) == 0L)
     AbortHello(hwndFrame, hwndClient); /* Terminate the application    */

    WinSetWindowText(hwndFrame, "SAMPLE PROGRAM");

  if (!WinSetWindowPos( hwndFrame,      /* Shows and activates frame    */
                   HWND_TOP,            /* window at position 100, 100, */
                   100, 100, 400, 300,  /* and size 200, 200.           */
                   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                 ))
     AbortHello(hwndFrame, hwndClient); /* Terminate the application    */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
  WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
  WinTerminate( hab );                   /* Terminate the application    */
} /* End of main */

MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  APIRET rc ;

  switch( msg )
  {
    case WM_COMMAND:
      {
      USHORT command;                   /* WM_COMMAND command value     */
      command = SHORT1FROMMP(mp1);      /* Extract the command value    */
      switch (command)
      {
        case ID_OPTION1:   /* DosS */
          rc= DosKick(hwnd,0);
          break;
        case ID_OPTION2:   /* DOS  */
          rc= DosKick(hwnd,1);
          break;
       case ID_OPTION3:    /* WINOS2 S */
          rc= DosKick(hwnd,2);
          break;
       case ID_OPTION4:    /* WINOS2 S */
          rc = WinKick(hwnd);
          break;
       case ID_OPTION5:    /* WINOS2 S */
         {
          WinDlgBox(HWND_DESKTOP,       /* Place anywhere on desktop    */
                    hwndFrame,         /* Owned by frame               */
                    MyDlgProc,
                    (HMODULE)0,        /* Module handle                */
                    ID_MYDLG,       /* Dialog identifier in resource*/
                    NULL);             /* Initialization data          */
         }
         break;
        case ID_EXITPROG:
          WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
          break;
        default:
          return WinDefWindowProc( hwnd, msg, mp1, mp2 );
      }

      break;
      }
    case WM_ERASEBACKGROUND:
      return (MRESULT)( TRUE );
    case WM_PAINT:
      {
      HPS    hps;                       /* Presentation Space handle    */
      RECTL  rc;                        /* Rectangle coordinates        */
      POINTL pt;                        /* String screen coordinates    */
                                        /* Create a presentation space  */
      hps = WinBeginPaint( hwnd, 0L, &rc );
      pt.x = 60; pt.y = 70;             /* Set the text coordinates,    */
      GpiSetColor( hps, CLR_NEUTRAL );         /* colour of the text,   */
      GpiSetBackColor( hps, CLR_BACKGROUND );  /* its background and    */
      GpiSetBackMix( hps, BM_OVERPAINT );      /* how it mixes,         */
                                               /* and draw the string...*/
      GpiCharStringAt( hps, &pt, (LONG)strlen( szString ), szString );
      WinEndPaint( hps );                      /* Drawing is complete   */
      break;
      }
    case WM_CLOSE:
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );/* Cause termination*/
      break;
    default:

      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

VOID AbortHello(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ       pszOffSet;
   void      stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
         WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                       hwndFrame,            /* Owner window is our frame */
                       (PSZ)pszErrMsg,       /* PMWIN Error message       */
                       "Error Msg",          /* Title bar message         */
                       MSGBOXID,             /* Message identifier        */
                       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End of AbortHello */

MRESULT EXPENTRY MyDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  switch ( msg )
  {
    case WM_COMMAND:                    /* Posted by pushbutton or key  */
      switch( SHORT1FROMMP( mp1 ) )     /* Extract the command value    */
      {
        case DID_OK:                    /* The Enter pushbutton or key. */
        case DID_CANCEL:                    /* The Enter pushbutton or key. */
          WinDismissDlg( hwndDlg, TRUE );  /* Removes the dialog box    */
          return (MRESULT) FALSE;
      }
      break;
    default:
      return WinDefDlgProc( hwndDlg, msg, mp1, mp2 );
  }
  return (MRESULT) FALSE;
}


ULONG DosKick(HWND hwnd,ULONG dostype){


    char        szFailName[szLength];

    STARTDATA   startdata;
    ULONG       pidsession;
    PID         pid;
    APIRET      rc;

    startdata.Length          = sizeof(STARTDATA);
    startdata.Related         = SSF_RELATED_INDEPENDENT;
    startdata.FgBg            = SSF_FGBG_FORE;
    startdata.TraceOpt        = SSF_TRACEOPT_NONE;
    startdata.PgmInputs       = 0;
    startdata.TermQ           = 0;

    startdata.InheritOpt      = SSF_INHERTOPT_PARENT;
    startdata.IconFile        = 0;
    startdata.PgmHandle       = 0;
    startdata.PgmControl      = SSF_CONTROL_VISIBLE;
    startdata.InitXPos        = 0;
    startdata.InitYPos        = 0;
    startdata.InitXSize       = 500;
    startdata.InitYSize       = 300;

    startdata.Reserved = 0;
    startdata.ObjectBuffer=szFailName;
    startdata.ObjectBuffLen=sizeof(szFailName);


  switch(dostype){
    case 0:/*  DOS/V Fullscreen  */
       startdata.PgmTitle        = "DOS/V Fullscreen";
       startdata.PgmName         = "C:\\OS2\\MDOS\\COMMAND.COM";
       startdata.Environment     = "*DOS_MODE=DOS/V\0";
       startdata.SessionType     = SSF_TYPE_VDM;
       break;
    case 1:/*  Windowed DOS/V    */
       startdata.PgmTitle        = "DOS/V Windowed";
       startdata.PgmName         = "C:\\OS2\\MDOS\\COMMAND.COM";
       startdata.Environment     = "*DOS_MODE=DOS/V\0";
       startdata.SessionType     = SSF_TYPE_WINDOWEDVDM;
       break;

    case 2:/*  WinOS2 Fullscreen  */
       startdata.PgmTitle        = "WINOS2 Fullscreen";
       startdata.PgmInputs       = "/e";
       startdata.PgmName         = "winos2.com";
       startdata.Environment     = "*DOS_MODE=DOS/V\0"
                                   "DPMI_MOMORY_LIMIT=64\0"
                                   "KBD_ALTHOME_BYPASS=1\0";
       startdata.SessionType     = SSF_TYPE_VDM;
       break;
   }
       rc = DosStartSession(&startdata,&pidsession,&pid);

       if(rc!=0)
             WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                           HWND_DESKTOP,         /* Owner window is our frame */
                          (PSZ)"Error !!!!", /* PMWIN Error message       */
                          "Error DLG BOX",                 /* Title bar message         */
                           MSGBOXID1,                       /* Message identifier        */
                           MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      return(rc);
}

ULONG WinKick(HWND hwnd){

                        HAPP        happ;
                        PROGDETAILS details;
                        APIRET  rc;
                        int  i;

                        details.Length          = sizeof(PROGDETAILS);
                        details.progt.progc     = PROG_31_ENHSEAMLESSVDM,
                        details.progt.fbVisible = SHE_VISIBLE;
                        details.pszTitle        = "TEST";
                        details.pszExecutable   = "PROGMAN.EXE";
                        details.pszParameters   = NULL;
                        details.pszStartupDir   = "c:\\OS2\\MDOS\\WINJOS2";
                        details.pszIcon         = NULL;
                        details.pszEnvironment  = "WIN SET_DDE=0\0"
                                                  "*FEP_MODE=OS2_FS_FEP\0"
                                                  "KBD_ALTHOME_BYPASS=1\0"
                                                  "KBD_CTRL_BYPASS=CTRL_ESC\0"
                                                  "VIDEO_SWITCH_NOTIFICATION=1\0"
                                                  "VIDEO_8514A_XGA_IOTRAP=0\0"
                                                  "*DOS_MODE=DOS/V\0"
                                                  "DPMI_MEMORY_LIMIT=64\0"
                                                  "WIN_DDE=0\0"
                                                  "WIN_CLIPBOARD=0\0\0";
                        details.swpInitial.fl   = SWP_ACTIVATE;
                        details.swpInitial.cy   = 0;
                        details.swpInitial.cx   = 0;
                        details.swpInitial.y    = 0;
                        details.swpInitial.x    = 0;
                        details.swpInitial.hwndInsertBehind = HWND_TOP;
                        details.swpInitial.hwnd = hwnd;
                        details.swpInitial.ulReserved1 = 0;
                        details.swpInitial.ulReserved2 = 0;

                        happ = WinStartApp(hwnd, &details,
                                                 NULL,
                                                 NULL,
                                                 SAF_INSTALLEDCMDLINE |
                                                 SAF_STARTCHILDAPP);
                        rc = WinGetLastError(hab);
                        return(rc);
}
